<template>
  <div>
    <canvas ref="chart">
      <p>{{ pieLabel }}</p>
    </canvas>
    <StatsList
      :total-count="totalCount"
      :stats="stats"
    />
  </div>
</template>

<script setup>
  const { $buildChart } = useNuxtApp()

  const props = defineProps({
    pieLabel: {
      type: String,
      required: true
    },
    stats: {
      type: Array,
      required: true
    },
    totalCount: {
      type: Number,
      required: true
    }
  })

  const chart = ref(null)

  onMounted(() => {
    plotChart()
  })

  function plotChart() {
    $buildChart(chart.value, {
      type: 'pie',
      data: {
        labels: props.stats.map(({ label }) => label),
        datasets: [
          {
            label: props.pieLabel,
            data: props.stats.map(({ count }) => count),
            backgroundColor: props.stats.map(({ color }) => color),
            hoverOffset: 4
          }
        ]
      }
    })
  }
</script>
